﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Problems.Instances;
using HeuristicLab.Problems.VehicleRouting.Interfaces;
using System;

namespace HeuristicLab.Problems.VehicleRouting.Interpreters {
  public struct VRPInstanceDescription {
    public string Name { get; set; }
    public string Description { get; set; }
    public IVRPProblemInstance ProblemInstance { get; set; }
    public double? BestKnownQuality { get; set; }
    public IVRPEncoding BestKnownSolution { get; set; }
  }

  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("299C4C47-84F8-4EAA-8F52-0ABCB34E154E")]
  public interface IVRPDataInterpreter {
    VRPInstanceDescription Interpret(IVRPData data);
  }

  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("D9F445BD-9300-43BB-A4F3-58AED53A67E8")]
  public interface IVRPDataInterpreter<T> : IVRPDataInterpreter where T : IVRPData {
  }
}
